org.eclipse.january.dataset

## Class ObjectDatasetBase

- java.lang.Object
- - org.eclipse.january.dataset.LazyDatasetBase
  - - org.eclipse.january.dataset.AbstractDataset
    - - org.eclipse.january.dataset.ObjectDatasetBase

- All Implemented Interfaces:
    Serializable, Dataset, IDataset, ILazyDataset, IMetadataProvider, INameable
  Direct Known Subclasses:
    ObjectDataset

      public class ObjectDatasetBase
      extends AbstractDataset

  Extend dataset for Object values // PRIM_TYPE
  See Also:
    Serialized Form

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected Object[]` | `data`

    - ### Fields inherited from class org.eclipse.january.dataset.AbstractDataset

      `base, BLOCK_CLOSE, BLOCK_OPEN, odata, offset, size, stride, stringFormat`

    - ### Fields inherited from class org.eclipse.january.dataset.LazyDatasetBase

      `catchExceptions, logger, metadata, name, shape`

    - ### Fields inherited from interface org.eclipse.january.dataset.Dataset

      `ARRAYFLOAT32, ARRAYFLOAT64, ARRAYINT16, ARRAYINT32, ARRAYINT64, ARRAYINT8, ARRAYMUL, BOOL, COMPLEX, COMPLEX128, COMPLEX64, DATE, FLOAT, FLOAT32, FLOAT64, INT, INT16, INT32, INT64, INT8, OBJECT, RGB, STRING`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `ObjectDatasetBase` | `clone()` Clone dataset
    `boolean` | `containsInfs()`
    `boolean` | `containsInvalidNumbers()`
    `boolean` | `containsNans()`
    `void` | `copyItemsFromAxes(int[] pos, boolean[] axes, Dataset dest)` Copy content from axes in given position to array
    `protected static Object[]` | `createArray(int size)`
    `boolean` | `equals(Object obj)`
    `ObjectDatasetBase` | `fill(Object obj)` Fill dataset with given object
    `void` | `fillDataset(Dataset result, IndexIterator iter)` Populate another dataset with part of current dataset
    `Object` | `get()`
    `Object` | `get(int... pos)`
    `Object` | `get(int i)`
    `Object` | `get(int i, int j)`
    `Object` | `getAbs(int index)` Get a value from an absolute index of the internal array.
    `boolean` | `getBoolean()` Get first item as a boolean.
    `boolean` | `getBoolean(int... pos)`
    `boolean` | `getBoolean(int i)` Get an item from given position as a boolean.
    `boolean` | `getBoolean(int i, int j)` Get an item from given position as a boolean.
    `protected int` | `getBufferLength()`
    `byte` | `getByte()` Get first item as a byte.
    `byte` | `getByte(int... pos)`
    `byte` | `getByte(int i)` Get an item from given position as a byte.
    `byte` | `getByte(int i, int j)` Get an item from given positionj as a byte.
    `Object[]` | `getData()` This is a typed version of `AbstractDataset.getBuffer()`
    `double` | `getDouble()` Get first item as a double.
    `double` | `getDouble(int... pos)`
    `double` | `getDouble(int i)` Get an item from given position as a double.
    `double` | `getDouble(int i, int j)` Get an item from given position as a double.
    `int` | `getDType()`
    `boolean` | `getElementBooleanAbs(int index)` Get an element from given absolute index as a boolean.
    `double` | `getElementDoubleAbs(int index)` Get an element from given absolute index as a double.
    `long` | `getElementLongAbs(int index)` Get an element from given absolute index as a long.
    `float` | `getFloat()` Get first item as a float.
    `float` | `getFloat(int... pos)`
    `float` | `getFloat(int i)` Get an item from given position as a float.
    `float` | `getFloat(int i, int j)` Get an item from given position as a float.
    `int` | `getInt()` Get first item as an int.
    `int` | `getInt(int... pos)`
    `int` | `getInt(int i)` Get an item from given position as an int.
    `int` | `getInt(int i, int j)` Get an item from given position as an int.
    `long` | `getLong()` Get first item as a long.
    `long` | `getLong(int... pos)`
    `long` | `getLong(int i)` Get an item from given position as a long.
    `long` | `getLong(int i, int j)` Get an item from given position as a long.
    `Object` | `getObject()` Get first item as an object.
    `Object` | `getObject(int... pos)`
    `Object` | `getObject(int i)` Get an item from given position as an object.
    `Object` | `getObject(int i, int j)` Get an item from given position as an object.
    `Object` | `getObjectAbs(int index)` Get an item from given absolute index as an object.
    `short` | `getShort()` Get first item as a short.
    `short` | `getShort(int... pos)`
    `short` | `getShort(int i)` Get an item from given position as a short.
    `short` | `getShort(int i, int j)` Get an item from given position as a short.
    `ObjectDatasetBase` | `getSlice(SliceIterator siter)` Get a slice of the dataset.
    `String` | `getString()` Get first item as a string.
    `String` | `getString(int... pos)`
    `String` | `getString(int i)` Get an item from given position as a string.
    `String` | `getString(int i, int j)` Get an item from given position as a string.
    `String` | `getStringAbs(int index)` Get an item from given absolute index as a string.
    `ObjectDatasetBase` | `getUniqueItems()` Get unique items
    `ObjectDatasetBase` | `getView(boolean deepCopyMetadata)`
    `int` | `hashCode()`
    `ObjectDatasetBase` | `iadd(Object b)` In-place addition with object o
    `ObjectDatasetBase` | `idivide(Object b)` In-place division with object o
    `ObjectDatasetBase` | `ifloor()` In-place floor
    `ObjectDatasetBase` | `imultiply(Object b)` In-place multiplication with object o
    `ObjectDatasetBase` | `ipower(Object b)` In-place raise to power of object o
    `ObjectDatasetBase` | `iremainder(Object b)` In-place remainder
    `ObjectDatasetBase` | `isubtract(Object b)` In-place subtraction with object o
    `int[]` | `maxPos(boolean... ignoreInvalids)`
    `int[]` | `minPos(boolean... ignoreInvalids)`
    `double` | `residual(Object b, Dataset w, boolean ignoreNaNs)` Calculate residual of dataset with object o and weight.
    `void` | `resize(int... newShape)` Change shape and size of dataset in-place
    `void` | `set(Object obj)` Set the value given by object at the first position.
    `void` | `set(Object obj, int... pos)` Set the value given by object at given position
    `void` | `set(Object obj, int i)` Set the value given by object at given position.
    `void` | `set(Object obj, int i, int j)` Set the value given by object at given position.
    `void` | `setAbs(int index, Object val)` Set a value at absolute index in the internal array.
    `ObjectDatasetBase` | `setBy1DIndex(Object obj, Dataset index)` This is modelled after the NumPy set item with an index dataset
    `ObjectDatasetBase` | `setByBoolean(Object obj, Dataset selection)` This is modelled after the NumPy set item with a condition specified by a boolean dataset
    `ObjectDatasetBase` | `setByIndexes(Object obj, Object... indexes)` This is modelled after the NumPy set item with an array of indexing objects
    `protected void` | `setData()` Set aliased data as base data
    `void` | `setItem(Object value)` Sets the value at first point to the passed value.
    `void` | `setItem(Object value, int... pos)` Sets the value at a particular point to the passed value
    `void` | `setItem(Object value, int i)` Sets the value at a particular point to the passed value.
    `void` | `setItem(Object value, int i, int j)` Sets the value at a particular point to the passed value.
    `protected void` | `setItemDirect(int dindex, int sindex, Object src)` Set item from compatible dataset in a direct and speedy way.
    `void` | `setItemsOnAxes(int[] pos, boolean[] axes, Object src)` Set content on axes in given position to values in array
    `void` | `setObjectAbs(int index, Object obj)` Set an item at absolute index from an object.
    `ObjectDatasetBase` | `setSlice(Object obj, IndexIterator siter)`
    `ObjectDatasetBase` | `sort(Integer axis)` In-place sort of dataset

    - ### Methods inherited from class org.eclipse.january.dataset.AbstractDataset

      `all, all, any, any, argMax, argMax, argMin, argMin, calcSteps, cast, cast, cast, checkAxis, checkAxis, checkCompatibility, copy, copy, copyToView, count, count, createStrides, createStrides, createStrides, createStrides, fillData, flatten, get1DIndex, get1DIndex, get1DIndex, get1DIndexFromShape, get1DIndexFromShape, getBooleanIterator, getBooleanIterator, getBroadcastView, getBuffer, getBy1DIndex, getByBoolean, getByIndexes, getElementClass, getElementsPerItem, getError, getError, getError, getError, getErrorArray, getErrorArray, getErrorArray, getErrorBuffer, getErrors, getFirst1DIndex, getIndices, getInternalSquaredError, getItemBytes, getIterator, getIterator, getMaxLineLength, getMetadataMap, getName, getNbytes, getNDPosition, getOffset, getPositionIterator, getRank, getRealPart, getRealView, getShape, getShapeRef, getSize, getSlice, getSlice, getSlice, getSlice, getSlice, getSlice, getSliceIterator, getSliceIterator, getSliceIteratorFromAxes, getSliceView, getSliceView, getSliceView, getStats, getStrides, getStringStats, getTransposedView, hasFloatingPointElements, ifloorDivide, isCompatibleWith, isComplex, max, max, mean, mean, min, min, overrideInternal, peakToPeak, peakToPeak, product, product, reshape, residual, residual, rootMeanSquare, rootMeanSquare, setErrorBuffer, setMaxLineLength, setName, setShape, setSlice, setSlice, setSlice, setStringFormat, squeeze, squeeze, squeezeEnds, stdDeviation, stdDeviation, stdDeviation, stdDeviation, sum, sum, swapAxes, synchronizedCopy, toString, toString, transpose, variance, variance, variance, variance`

    - ### Methods inherited from class org.eclipse.january.dataset.LazyDatasetBase

      `addMetadata, checkPermutatedAxes, clearMetadata, copyMetadata, copyMetadata, createFromSerializable, dirtyMetadata, findMetadataTypeSubInterfaces, getErrorMetadata, getFirstMetadata, getMetadata, getMetadata, hasErrors, reshapeMetadata, restoreMetadata, setDirty, setErrors, setMetadata, sliceMetadata, transposeMetadata`

    - ### Methods inherited from class java.lang.Object

      `finalize, getClass, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface org.eclipse.january.dataset.Dataset

      `setDirty`

    - ### Methods inherited from interface org.eclipse.january.dataset.IDataset

      `getMetadata`

    - ### Methods inherited from interface org.eclipse.january.dataset.ILazyDataset

      `addMetadata, clearMetadata, hasErrors, setErrors, setMetadata`

    - ### Methods inherited from interface org.eclipse.january.dataset.IMetadataProvider

      `getFirstMetadata, getMetadata`

- - ### Field Detail

    - #### data

          protected Object[] data

  - ### Method Detail

    - #### setData

          protected void setData()

      Description copied from class: `AbstractDataset`
      Set aliased data as base data
      Specified by:
        `setData` in class `AbstractDataset`

    - #### createArray

          protected static Object[] createArray(int size)

    - #### getDType

          public int getDType()

      Specified by:
        `getDType` in interface `Dataset`
      Specified by:
        `getDType` in class `LazyDatasetBase`
      Returns:
        type of dataset item

    - #### equals

          public boolean equals(Object obj)

      Overrides:
        `equals` in class `AbstractDataset`

    - #### hashCode

          public int hashCode()

      Overrides:
        `hashCode` in class `AbstractDataset`

    - #### clone

          public ObjectDatasetBase clone()

      Description copied from interface: `ILazyDataset`
      Clone dataset
      Specified by:
        `clone` in interface `Dataset`
      Specified by:
        `clone` in interface `IDataset`
      Specified by:
        `clone` in interface `ILazyDataset`
      Specified by:
        `clone` in class `AbstractDataset`
      Returns:
        a (shallow) copy of dataset

    - #### fill

          public ObjectDatasetBase fill(Object obj)

      Description copied from interface: `Dataset`
      Fill dataset with given object
      Returns:
        filled dataset with each item being equal to the given object

    - #### getData

          public Object[] getData()

      This is a typed version of `AbstractDataset.getBuffer()`
      Returns:
        data buffer as linear array

    - #### getBufferLength

          protected int getBufferLength()

      Specified by:
        `getBufferLength` in class `AbstractDataset`
      Returns:
        entire buffer length

    - #### getView

          public ObjectDatasetBase getView(boolean deepCopyMetadata)

      Specified by:
        `getView` in interface `Dataset`
      Specified by:
        `getView` in class `AbstractDataset`
      Parameters:
        `deepCopyMetadata` - if true then deep-copy metadata
      Returns:
        whole view of dataset (i.e. data buffer is shared)

    - #### getAbs

          public Object getAbs(int index)

      Get a value from an absolute index of the internal array. This is an internal method with no checks so can be dangerous. Use with care or ideally with an iterator.
      Parameters:
        `index` - absolute index
      Returns:
        value

    - #### getElementBooleanAbs

          public boolean getElementBooleanAbs(int index)

      Description copied from interface: `Dataset`
      Get an element from given absolute index as a boolean. See warning in interface doc
      Returns:
        element as boolean

    - #### getElementDoubleAbs

          public double getElementDoubleAbs(int index)

      Description copied from interface: `Dataset`
      Get an element from given absolute index as a double. See warning in interface doc
      Returns:
        element as double

    - #### getElementLongAbs

          public long getElementLongAbs(int index)

      Description copied from interface: `Dataset`
      Get an element from given absolute index as a long. See warning in interface doc
      Returns:
        element as long

    - #### getObjectAbs

          public Object getObjectAbs(int index)

      Description copied from interface: `Dataset`
      Get an item from given absolute index as an object. See warning in interface doc
      Returns:
        item

    - #### getStringAbs

          public String getStringAbs(int index)

      Description copied from interface: `Dataset`
      Get an item from given absolute index as a string. See warning in interface doc
      Returns:
        item

    - #### setAbs

          public void setAbs(int index,
                    Object val)

      Set a value at absolute index in the internal array. This is an internal method with no checks so can be dangerous. Use with care or ideally with an iterator.
      Parameters:
        `index` - absolute index
        `val` - new value

    - #### setItemDirect

          protected void setItemDirect(int dindex,
                           int sindex,
                           Object src)

      Description copied from class: `AbstractDataset`
      Set item from compatible dataset in a direct and speedy way. Remember to setDirty afterwards.
      Specified by:
        `setItemDirect` in class `AbstractDataset`
        `src` - is the source data buffer

    - #### setObjectAbs

          public void setObjectAbs(int index,
                          Object obj)

      Description copied from interface: `Dataset`
      Set an item at absolute index from an object. See warning in interface doc

    - #### get

          public Object get()

      Returns:
        item in first position
      Since:
        2.0

    - #### get

          public Object get(int i)

      Parameters:
        `i` -
      Returns:
        item in given position

    - #### get

          public Object get(int i,
                   int j)

      Parameters:
        `i` -
        `j` -
      Returns:
        item in given position

    - #### get

          public Object get(int... pos)

      Parameters:
        `pos` -
      Returns:
        item in given position

    - #### getObject

          public Object getObject()

      Description copied from interface: `Dataset`
      Get first item as an object. The dataset must not be null
      Returns:
        item

    - #### getObject

          public Object getObject(int i)

      Description copied from interface: `Dataset`
      Get an item from given position as an object. The dataset must be 1D
      Returns:
        item

    - #### getObject

          public Object getObject(int i,
                         int j)

      Description copied from interface: `Dataset`
      Get an item from given position as an object. The dataset must be 2D
      Returns:
        item

    - #### getObject

          public Object getObject(int... pos)

      Returns:
        Item in given position as an object

    - #### getString

          public String getString()

      Description copied from interface: `Dataset`
      Get first item as a string. The dataset must not be null
      Returns:
        item

    - #### getString

          public String getString(int i)

      Description copied from interface: `Dataset`
      Get an item from given position as a string. The dataset must be 1D
      Returns:
        item

    - #### getString

          public String getString(int i,
                         int j)

      Description copied from interface: `Dataset`
      Get an item from given position as a string. The dataset must be 2D
      Returns:
        item

    - #### getString

          public String getString(int... pos)

      Returns:
        Item in given position as a string

    - #### getDouble

          public double getDouble()

      Description copied from interface: `Dataset`
      Get first item as a double. The dataset must not be null
      Returns:
        item

    - #### getDouble

          public double getDouble(int i)

      Description copied from interface: `Dataset`
      Get an item from given position as a double. The dataset must be 1D
      Returns:
        item

    - #### getDouble

          public double getDouble(int i,
                         int j)

      Description copied from interface: `Dataset`
      Get an item from given position as a double. The dataset must be 2D
      Returns:
        item

    - #### getDouble

          public double getDouble(int... pos)

      Returns:
        Item in given position as a double

    - #### getFloat

          public float getFloat()

      Description copied from interface: `Dataset`
      Get first item as a float. The dataset must not be null
      Returns:
        item

    - #### getFloat

          public float getFloat(int i)

      Description copied from interface: `Dataset`
      Get an item from given position as a float. The dataset must be 1D
      Returns:
        item

    - #### getFloat

          public float getFloat(int i,
                       int j)

      Description copied from interface: `Dataset`
      Get an item from given position as a float. The dataset must be 2D
      Returns:
        item

    - #### getFloat

          public float getFloat(int... pos)

      Returns:
        Item in given position as a float

    - #### getLong

          public long getLong()

      Description copied from interface: `Dataset`
      Get first item as a long. The dataset must not be null
      Returns:
        item

    - #### getLong

          public long getLong(int i)

      Description copied from interface: `Dataset`
      Get an item from given position as a long. The dataset must be 1D
      Returns:
        item

    - #### getLong

          public long getLong(int i,
                     int j)

      Description copied from interface: `Dataset`
      Get an item from given position as a long. The dataset must be 2D
      Returns:
        item

    - #### getLong

          public long getLong(int... pos)

      Returns:
        Item in given position as a long

    - #### getInt

          public int getInt()

      Description copied from interface: `Dataset`
      Get first item as an int. The dataset must not be null
      Returns:
        item

    - #### getInt

          public int getInt(int i)

      Description copied from interface: `Dataset`
      Get an item from given position as an int. The dataset must be 1D
      Returns:
        item

    - #### getInt

          public int getInt(int i,
                   int j)

      Description copied from interface: `Dataset`
      Get an item from given position as an int. The dataset must be 2D
      Returns:
        item

    - #### getInt

          public int getInt(int... pos)

      Returns:
        Item in given position as an int

    - #### getShort

          public short getShort()

      Description copied from interface: `Dataset`
      Get first item as a short. The dataset must not be null
      Returns:
        item

    - #### getShort

          public short getShort(int i)

      Description copied from interface: `Dataset`
      Get an item from given position as a short. The dataset must be 1D
      Returns:
        item

    - #### getShort

          public short getShort(int i,
                       int j)

      Description copied from interface: `Dataset`
      Get an item from given position as a short. The dataset must be 2D
      Returns:
        item

    - #### getShort

          public short getShort(int... pos)

      Returns:
        Item in given position as a short

    - #### getByte

          public byte getByte()

      Description copied from interface: `Dataset`
      Get first item as a byte. The dataset must not be null
      Returns:
        item

    - #### getByte

          public byte getByte(int i)

      Description copied from interface: `Dataset`
      Get an item from given position as a byte. The dataset must be 1D
      Returns:
        item

    - #### getByte

          public byte getByte(int i,
                     int j)

      Description copied from interface: `Dataset`
      Get an item from given positionj as a byte. The dataset must be 2D
      Returns:
        item

    - #### getByte

          public byte getByte(int... pos)

      Returns:
        Item in given position as a byte

    - #### getBoolean

          public boolean getBoolean()

      Description copied from interface: `Dataset`
      Get first item as a boolean. The dataset must not be null
      Returns:
        item

    - #### getBoolean

          public boolean getBoolean(int i)

      Description copied from interface: `Dataset`
      Get an item from given position as a boolean. The dataset must be 1D
      Returns:
        item

    - #### getBoolean

          public boolean getBoolean(int i,
                           int j)

      Description copied from interface: `Dataset`
      Get an item from given position as a boolean. The dataset must be 2D
      Returns:
        item

    - #### getBoolean

          public boolean getBoolean(int... pos)

      Returns:
        Item in given position as a boolean

    - #### setItem

          public void setItem(Object value)

      Sets the value at first point to the passed value. The dataset must not be null
      Parameters:
        `value` -
      Since:
        2.0

    - #### setItem

          public void setItem(Object value,
                     int i)

      Sets the value at a particular point to the passed value. The dataset must be 1D
      Parameters:
        `value` -
        `i` -

    - #### setItem

          public void setItem(Object value,
                     int i,
                     int j)

      Sets the value at a particular point to the passed value. The dataset must be 2D
      Parameters:
        `value` -
        `i` -
        `j` -

    - #### setItem

          public void setItem(Object value,
                     int... pos)

      Sets the value at a particular point to the passed value
      Parameters:
        `value` -
        `pos` -

    - #### set

          public void set(Object obj)

      Description copied from interface: `Dataset`
      Set the value given by object at the first position. The dataset must not be null

    - #### set

          public void set(Object obj,
                 int i)

      Description copied from interface: `Dataset`
      Set the value given by object at given position. The dataset must be 1D

    - #### set

          public void set(Object obj,
                 int i,
                 int j)

      Description copied from interface: `Dataset`
      Set the value given by object at given position. The dataset must be 2D

    - #### set

          public void set(Object obj,
                 int... pos)

      Description copied from interface: `IDataset`
      Set the value given by object at given position

    - #### resize

          public void resize(int... newShape)

      Description copied from interface: `IDataset`
      Change shape and size of dataset in-place

    - #### sort

          public ObjectDatasetBase sort(Integer axis)

      Description copied from interface: `Dataset`
      In-place sort of dataset
      Parameters:
        `axis` - to sort along. If null, then the flattened view is sorted
      Returns:
        sorted dataset

    - #### getUniqueItems

          public ObjectDatasetBase getUniqueItems()

      Description copied from interface: `Dataset`
      Get unique items
      Returns:
        a sorted dataset of unique items

    - #### getSlice

          public ObjectDatasetBase getSlice(SliceIterator siter)

      Description copied from class: `AbstractDataset`
      Get a slice of the dataset. The returned dataset is a copied selection of items
      Specified by:
        `getSlice` in class `AbstractDataset`
      Parameters:
        `siter` - Slice iterator
      Returns:
        The dataset of the sliced data

    - #### fillDataset

          public void fillDataset(Dataset result,
                         IndexIterator iter)

      Description copied from interface: `Dataset`
      Populate another dataset with part of current dataset
        `iter` - over current dataset

    - #### setByBoolean

          public ObjectDatasetBase setByBoolean(Object obj,
                                       Dataset selection)

      Description copied from interface: `Dataset`
      This is modelled after the NumPy set item with a condition specified by a boolean dataset
      Parameters:
        `obj` - specifies the object used to set the selected items
        `selection` - a boolean dataset of same shape to use for selecting items
      Returns:
        The dataset with modified content

    - #### setBy1DIndex

          public ObjectDatasetBase setBy1DIndex(Object obj,
                                       Dataset index)

      Description copied from interface: `Dataset`
      This is modelled after the NumPy set item with an index dataset
      Parameters:
        `obj` - specifies the object used to set the selected items
        `index` - an integer dataset
      Returns:
        The dataset with modified content

    - #### setByIndexes

          public ObjectDatasetBase setByIndexes(Object obj,
                                       Object... indexes)

      Description copied from interface: `Dataset`
      This is modelled after the NumPy set item with an array of indexing objects
      Parameters:
        `obj` - specifies the object used to set the selected items
        `indexes` - an array of integer dataset, boolean dataset, slices or null entries (same as full slices)
      Returns:
        The dataset with modified content

    - #### setSlice

          public ObjectDatasetBase setSlice(Object obj,
                                   IndexIterator siter)

      Parameters:
        `obj` - specifies the object used to set the specified slice
        `siter` - specifies the slice iterator
      Returns:
        The dataset with the sliced set to object

    - #### copyItemsFromAxes

          public void copyItemsFromAxes(int[] pos,
                               boolean[] axes,
                               Dataset dest)

      Description copied from interface: `Dataset`
      Copy content from axes in given position to array
      Parameters:
        `pos` - - null means position at origin
        `axes` - - true means copy

    - #### setItemsOnAxes

          public void setItemsOnAxes(int[] pos,
                            boolean[] axes,
                            Object src)

      Description copied from interface: `Dataset`
      Set content on axes in given position to values in array
        `axes` - - true means copy

    - #### maxPos

          public int[] maxPos(boolean... ignoreInvalids)

      Parameters:
        `ignoreInvalids` - - see `IDataset.max(boolean...)`
      Returns:
        Position of maximum value (or first position if there are more than one)

    - #### minPos

          public int[] minPos(boolean... ignoreInvalids)

      Parameters:
        `ignoreInvalids` - - see `IDataset.max(boolean...)`
      Returns:
        Position of minimum value (or first position if there are more than one)

    - #### containsNans

          public boolean containsNans()

      Returns:
        true if dataset contains any NaNs

    - #### containsInfs

          public boolean containsInfs()

      Returns:
        true if dataset contains any infinities

    - #### containsInvalidNumbers

          public boolean containsInvalidNumbers()

      Returns:
        true if dataset contains any NaNs or infinities

    - #### iadd

          public ObjectDatasetBase iadd(Object b)

      Description copied from interface: `Dataset`
      In-place addition with object o
      Returns:
        sum dataset

    - #### isubtract

          public ObjectDatasetBase isubtract(Object b)

      Description copied from interface: `Dataset`
      In-place subtraction with object o
      Returns:
        difference dataset

    - #### imultiply

          public ObjectDatasetBase imultiply(Object b)

      Description copied from interface: `Dataset`
      In-place multiplication with object o
      Returns:
        product dataset

    - #### idivide

          public ObjectDatasetBase idivide(Object b)

      Description copied from interface: `Dataset`
      In-place division with object o
      Returns:
        dividend dataset

    - #### ifloor

          public ObjectDatasetBase ifloor()

      Description copied from interface: `Dataset`
      In-place floor
      Returns:
        floored dataset

    - #### iremainder

          public ObjectDatasetBase iremainder(Object b)

      Description copied from interface: `Dataset`
      In-place remainder
      Returns:
        remaindered dataset

    - #### ipower

          public ObjectDatasetBase ipower(Object b)

      Description copied from interface: `Dataset`
      In-place raise to power of object o
      Returns:
        raised dataset

    - #### residual

          public double residual(Object b,
                        Dataset w,
                        boolean ignoreNaNs)

      Description copied from interface: `Dataset`
      Calculate residual of dataset with object o and weight. The weight is used to multiply the squared differences
        `ignoreNaNs` - if true, skip NaNs
      Returns:
        sum of the squares of the differences

Copyright © 2017. All rights reserved.